/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.1
* Date               : 2019/11/05
* Description        : ӻӦϵͳʼ
*******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "CONFIG.h"
#include "CH57x_common.h"
#include "HAL.h"
#include "gattprofile.h"
#include "peripheral.h"
#include "i2c.h"
#include "oled.h"
#include "partcheck.h"
#include "exti.h"
#include "display.h"

/*********************************************************************
 * GLOBAL TYPEDEFS
 */
__align(4) u32 MEM_BUF[BLE_MEMHEAP_SIZE/4];

#if (defined (BLE_MAC)) && (BLE_MAC == TRUE)
u8C MacAddr[6] = {0x84,0xC2,0xE4,0x03,0x02,0x03};
#endif

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CHECKOVER = 0;
UINT8 BLEBUFREADY = 0;
extern COMPONENTTYPE ComponentFound;					//
extern COMPONENTPARAMETER ComponentParam;			//

int main( void ) 
{
//#ifdef DEBUG
//  GPIOA_SetBits(bTXD1);
//  GPIOA_ModeCfg(bTXD1, GPIO_ModeOut_PP_5mA);
//  UART1_DefInit( );
//#endif   	
	I2C_Init();
	ADC_Init();
	EXTI_Init();
	OLED_Init();
	Ready_Display();
	
//  PRINT("%s\n",VER_LIB);
  CH57X_BLEInit( );
	HAL_Init( );
	GAPRole_PeripheralInit( );
	Peripheral_Init( ); 
	
	while(1)
	{
		TMOS_SystemProcess( );
		if(CHECKOVER)
		{
			if(ComponentFound == COMPONENT_NONE)
				Error_Report();
			else if(ComponentFound == COMPONENT_RESISTANCE)
				Resistance_Display(ComponentParam);
			else if(ComponentFound == COMPONENT_CAPACITANCE)
				Capacitance_Display(ComponentParam);
			else if(ComponentFound == COMPONENT_INDUCTANCE)
				Inductance_Display(ComponentParam);
			else if(ComponentFound == COMPONENT_DIODE)
				Diode_Display(ComponentParam);
			else if(ComponentFound == COMPONENT_BJT)
				BJT_Display(ComponentParam);
			else if(ComponentFound == COMPONENT_JFET)
				JFET_Display(ComponentParam);
			else if(ComponentFound == COMPONENT_MOS)
				MOS_Display(ComponentParam);
			
			ComponentFound = COMPONENT_NONE;
			BLEBUFREADY = 1;
			CHECKOVER = 0;
		}
	}
}

/******************************** endfile @ main ******************************/
void GPIO_IRQHandler(void)
{
	DelayMs(10);
	if(!GPIOA_ReadPortPin(GPIO_Pin_9))
	{
		Testing_Display();
		Component_QuickCheck(TP1, TP2, TP3);
		CHECKOVER = 1;
	}
	
	GPIOA_ClearITFlagBit(GPIO_Pin_9);	
}
