#include "adc.h"

signed short RoughCalib_Value=0;			//ADCƫֵ

/*******************************************************************************
* Function Name  : ADC_Init
* Description    : ADCʼ,PA13,PA14,PA15
* Input          : None			
* Return         : None
*******************************************************************************/
void ADC_Init(void)
{
	GPIOA_ModeCfg(GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15, GPIO_ModeIN_Floating);
	ADC_ExtSingleChSampInit( SampleFreq_4, ADC_PGA_0 );
	
	GPIOA_ModeCfg(GPIO_Pin_5, GPIO_ModeIN_Floating);
	RoughCalib_Value = ADC_DataCalib_Rough();				//ȡƫֵ
}


/*******************************************************************************
* Function Name  : ADC_PGASet
* Description    : ADC汶
* Input          : mode: οADC_SignalPGATypeDefģʽ		
* Return         : None
*******************************************************************************/
void ADC_PGASet(ADC_SignalPGATypeDef mode)
{
	ADC_PGACfg(mode);
	
	GPIOA_ModeCfg(GPIO_Pin_5, GPIO_ModeIN_Floating);
	RoughCalib_Value = ADC_DataCalib_Rough();
}


/*******************************************************************************
* Function Name  : ADC_AutoPGASet
* Description    : ADC汶Զѡ
* Input          : ch: ͨѡ
* Return         : ADC_SignalPGATypeDef: ģʽ
*******************************************************************************/
ADC_SignalPGATypeDef ADC_AutoPGASelect(UINT8 ch)
{
	UINT16 ADCVal = 0;
	ADC_SignalPGATypeDef mode = ADC_PGA_0;
	
	ADC_PGASet(mode);
	ADCVal = ADC_GetAverage(mode, ch, 5);			//ɼ5ADCȡƽֵ
	if(ADCVal > 4000)
	{
		mode = ADC_PGA_1_2;
		ADC_PGASet(mode);
		ADCVal = ADC_GetAverage(mode, ch, 5);
		if(ADCVal >4000)
		{
			mode = ADC_PGA_1_4;
		}
	}
	return mode;
}


/*******************************************************************************
* Function Name  : ADC_Get
* Description    : ȡADC()
* Input          : mode: ģʽ
									 ch: ͨѡ
* Return         : ADCVal: ADCֵ
*******************************************************************************/
UINT16 ADC_Get(ADC_SignalPGATypeDef mode, UINT8 ch)
{
	UINT16 ADCVal = 0;
	
	ADC_ChannelCfg(ch);
//	ADCVal = ADC_ExcutSingleConver();											//һתֵ
	ADCVal = ADC_ExcutSingleConver();
	
	if((RoughCalib_Value>0) || ((UINT16)abs(RoughCalib_Value)<ADCVal))
	{
		ADCVal += RoughCalib_Value;
	}

	ADC_DataCalib_Fine(&ADCVal, mode);
	
	return ADCVal;
}


/*******************************************************************************
* Function Name  : ADC_GetAverage
* Description    : ȡADC(ȡƽֵ)
* Input          : mode: ģʽ
									 ch: ͨѡ
									 time: β
* Return         : (UINT16)ADCֵ
*******************************************************************************/
UINT16 ADC_GetAverage(ADC_SignalPGATypeDef mode, UINT8 ch, UINT8 times)
{
	UINT8 i;
	UINT16 ADCVal = 0;
	UINT16 ADCSum = 0;
	
	ADC_ChannelCfg(ch);
	ADCVal = ADC_ExcutSingleConver();												//һתֵ
	for(i=0; i<times; ++i)
	{
		ADCVal = ADC_ExcutSingleConver();
		
		if((RoughCalib_Value>0) || ((UINT16)abs(RoughCalib_Value)<ADCVal))
		{
			ADCVal += RoughCalib_Value;
		}
		
		ADC_DataCalib_Fine(&ADCVal, mode);
		ADCSum += ADCVal;
	}
	
	return (ADCSum/times);	
}


/*******************************************************************************
* Function Name  : ADC_RealVol
* Description    : ADCʵʵѹֵ
* Input          : mode: ģʽ
									 val: ADCֵ
* Return         : (double)ʵʵѹֵ
*******************************************************************************/
double ADC_RealVol(ADC_SignalPGATypeDef mode, UINT16 val)
{
	if(mode == ADC_PGA_1_4)
		return (((double)val/512-3)*1.05);
	else if(mode == ADC_PGA_1_2)
		return (((double)val/1024-1)*1.05);
	else if(mode == ADC_PGA_0)
		return (((double)val/2048)*1.05);
	else if(mode == ADC_PGA_2)
		return (((double)val/4096+0.5)*1.05);
	else
		return -1;
}
