#include "display.h"

UINT8 BLENOTIBUF[50] = {0};			//

/*******************************************************************************
* Function Name  : BLENotiBuf_Clear
* Description    : BLENOTIBUF
* Input          : None
* Return         : None
*******************************************************************************/
void BLENOTIBUF_Clear(void)
{
	UINT8 i;
	for(i=0; i<50; ++i)
	{
		BLENOTIBUF[i] = 0;
	}
}


/*******************************************************************************
* Function Name  : Error_Report
* Description    : 
* Input          : None
* Return         : None
*******************************************************************************/
void Error_Report(void)
{
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowString(0, 0, (UINT8*)"Unknow, out of range, or damaged part!", 16);
	OLED_RefreshGram();
	
	BLENOTIBUF_Clear();
	strcpy((char*)BLENOTIBUF, "Unknow, out of range, or damaged part!\n");
}


/*******************************************************************************
* Function Name  : Ready_Display
* Description    : ʾ׼
* Input          : None
* Return         : None
*******************************************************************************/
void Ready_Display(void)
{
	UINT8 NAME_BUF[] = "Component Tester";
	UINT8 READY_BUF[] = "Ready!!!";
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowString(0, 0, NAME_BUF, 16);
	OLED_ShowString(0, 16, READY_BUF, 24);
	OLED_RefreshGram();
}


/*******************************************************************************
* Function Name  : Ready_Display
* Description    : ʾڲԽ
* Input          : None
* Return         : None
*******************************************************************************/
void Testing_Display(void)
{
	UINT8 NAME_BUF[] = "Component Tester";
	UINT8 TEST_BUF[] = "Testing...";
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowString(0, 0, NAME_BUF, 16);
	OLED_ShowString(0, 16, TEST_BUF, 24);
	OLED_RefreshGram();
}


/*******************************************************************************
* Function Name  : Resistance_Display
* Description    : ʾ(OLED+BLE)
* Input          : ComParam: Ԫ
* Return         : None
*******************************************************************************/
void Resistance_Display(COMPONENTPARAMETER ComParam)
{
	UINT8 RESTAG_BUF[3] = "[R]";
	UINT8 RESVAL_BUF[10];
	int len;
	
	len = sprintf((char*)RESVAL_BUF, "%.1f", ComParam.RESPARAM.ResVal); 
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowNum(0, 0, ComParam.RESPARAM.front-2, 1, 16);
	OLED_ShowResPic(8, 0);
	OLED_ShowNum(40, 0, ComParam.RESPARAM.rear-2, 1, 16);
	OLED_ShowString(104, 0, RESTAG_BUF, 16);
	OLED_ShowString(0, 16, RESVAL_BUF, 16);
	OLED_ShowOhmUnit(8*len, 16);
	OLED_RefreshGram();
	
	BLENOTIBUF_Clear();
	strcpy((char*)BLENOTIBUF, "Resistance = ");
	strcpy((char*)&BLENOTIBUF[13], (char*)RESVAL_BUF);
	strcpy((char*)&BLENOTIBUF[13+len], " Ohm\n");
}


/*******************************************************************************
* Function Name  : Capacitance_Display
* Description    : ݲʾ(OLED+BLE)
* Input          : ComParam: Ԫ
* Return         : None
*******************************************************************************/
void Capacitance_Display(COMPONENTPARAMETER ComParam)
{
	UINT8 CAPTAG_BUF[3] = "[C]";
	UINT8 CAPVAL_BUF[10];
	int len;

	len = sprintf((char*)CAPVAL_BUF, "%.2f", ComParam.CAPPARAM.CapVal); 
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowNum(0, 0, ComParam.CAPPARAM.front-2, 1, 16);
	OLED_ShowCapPic(8, 0);
	OLED_ShowNum(40, 0, ComParam.CAPPARAM.rear-2, 1, 16);
	OLED_ShowString(104, 0, CAPTAG_BUF, 16);
	OLED_ShowString(0, 16, CAPVAL_BUF, 16);
	OLED_ShowString(8*len, 16, (UINT8*)"nF", 16);
	OLED_RefreshGram();
	
	BLENOTIBUF_Clear();
	strcpy((char*)BLENOTIBUF, "Capacitance = ");
	strcpy((char*)&BLENOTIBUF[14], (char*)CAPVAL_BUF);
	strcpy((char*)&BLENOTIBUF[14+len], " nF\n");
}


/*******************************************************************************
* Function Name  : Inductance_Display
* Description    : вʾ(OLED+BLE)
* Input          : ComParam: Ԫ
* Return         : None
*******************************************************************************/
void Inductance_Display(COMPONENTPARAMETER ComParam)
{
	UINT8 INDTAG_BUF[3] = "[L]";
	UINT8 INDVAL_BUF[10];
	int len;

	len = sprintf((char*)INDVAL_BUF, "%.2f", ComParam.INDPARAM.IndVal); 
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowNum(0, 0, ComParam.INDPARAM.front-2, 1, 16);
	OLED_ShowIndPic(8, 0);
	OLED_ShowNum(40, 0, ComParam.INDPARAM.rear-2, 1, 16);
	OLED_ShowString(104, 0, INDTAG_BUF, 16);
	OLED_ShowString(0, 16, INDVAL_BUF, 16);
	OLED_ShowString(8*len, 16, (UINT8*)"nH", 16);
	OLED_RefreshGram();
	
	BLENOTIBUF_Clear();
	strcpy((char*)BLENOTIBUF, "Inductance = ");
	strcpy((char*)&BLENOTIBUF[14], (char*)INDVAL_BUF);
	strcpy((char*)&BLENOTIBUF[14+len], " nH\n");
}


/*******************************************************************************
* Function Name  : Diode_Display
* Description    : ܲʾ(OLED+BLE)
* Input          : ComParam: Ԫ
* Return         : None
*******************************************************************************/
void Diode_Display(COMPONENTPARAMETER ComParam)
{
	UINT8 DIOTAG_BUF[3] = "[D]";
	UINT8 UONVAL_BUF[10];
	UINT8 CJVAL_BUF[10];
	UINT8 len1,len2;
	
	len1 = sprintf((char*)UONVAL_BUF, "%.1f", ComParam.DiodeParam.Uon);
	if(ComParam.DiodeParam.Cj != (-1))
		len2 = sprintf((char*)CJVAL_BUF, "%.2f", ComParam.DiodeParam.Cj); 
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowNum(0, 0, ComParam.DiodeParam.front-2, 1, 16);
	OLED_ShowNum(40, 0, ComParam.DiodeParam.rear-2, 1, 16);
	OLED_ShowDioPic(8, 0);
	OLED_ShowString(104, 0, DIOTAG_BUF, 16);
	OLED_ShowString(0, 16, (UINT8*)"Uon=", 16);
	OLED_ShowString(32, 16, UONVAL_BUF, 16);
	OLED_ShowChar(8*(len1+4), 16, 'V', 16);
	if(ComParam.DiodeParam.Cj >0)
	{	
		OLED_ShowString(0, 32, (UINT8*)"Cj=", 16);
		OLED_ShowString(24, 32, CJVAL_BUF, 16);
		OLED_ShowString(24+8*len2, 16, (UINT8*)"nF", 16);
	}
	OLED_RefreshGram();
	
	BLENOTIBUF_Clear();
	strcpy((char*)BLENOTIBUF, "Diode: Uon = ");
	strcpy((char*)&BLENOTIBUF[13], (char*)UONVAL_BUF);
	strcpy((char*)&BLENOTIBUF[13+len1], " V");
	if(ComParam.DiodeParam.Cj >0)
	{	
		strcpy((char*)&BLENOTIBUF[15+len1], ", Cj = ");
		strcpy((char*)&BLENOTIBUF[22+len1], (char*)CJVAL_BUF);
		strcpy((char*)&BLENOTIBUF[22+len1+len2], " nF\n");
	}
	else
	{
		strcpy((char*)&BLENOTIBUF[15+len1], "\n");
	}
}


/*******************************************************************************
* Function Name  : BJT_Display
* Description    : BJTʾ(OLED+BLE)
* Input          : ComParam: Ԫ
* Return         : None
*******************************************************************************/
void BJT_Display(COMPONENTPARAMETER ComParam)
{
	UINT8 UONVAL_BUF[10];
	UINT8 HFEVAL_BUF[10];
	UINT8 len1, len2;

	len1 = sprintf((char*)UONVAL_BUF, "%.1f", ComParam.BJTPARAM.Ube);
	len2 = sprintf((char*)HFEVAL_BUF, "%u", ComParam.BJTPARAM.hFE); 
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowNum(0, 10, ComParam.BJTPARAM.b-2, 1, 12);
	OLED_ShowNum(30, 0, ComParam.BJTPARAM.c-2, 1, 12);
	OLED_ShowNum(30, 20, ComParam.BJTPARAM.e-2, 1, 12);
	
	BLENOTIBUF_Clear();
	if(ComParam.BJTPARAM.Channel == P_CHANNEL)
	{
		OLED_ShowPBJTPic(9, 0);
		OLED_ShowString(44, 0, (UINT8*)"NPN-BJT", 16);
		strcpy((char*)BLENOTIBUF, "NPN-BJT: Ube = ");
	}
	else if(ComParam.BJTPARAM.Channel == N_CHANNEL)
	{
		OLED_ShowNBJTPic(9, 0);
		OLED_ShowString(44, 0, (UINT8*)"PNP-BJT", 16);
		strcpy((char*)BLENOTIBUF, "PNP-BJT : Ube = ");
	}
	
	OLED_ShowString(44, 16, (UINT8*)"hFE=", 16);
	OLED_ShowString(76, 16, HFEVAL_BUF, 16);
	OLED_ShowString(44, 32, (UINT8*)"Ube=", 16);
	OLED_ShowString(76, 32, UONVAL_BUF, 16);
	OLED_ShowChar(8*len1+76, 32, 'V', 16);
	OLED_ShowString(0, 48, (UINT8*)"Pin ", 16);
	OLED_ShowNum(8*4, 48, ComParam.BJTPARAM.b-2, 1, 16);
	OLED_ShowString(8*5, 48, (UINT8*)"=B ", 16);
	OLED_ShowNum(8*8, 48, ComParam.BJTPARAM.c-2, 1, 16);
	OLED_ShowString(8*9, 48, (UINT8*)"=C ", 16);
	OLED_ShowNum(8*12, 48, ComParam.BJTPARAM.e-2, 1, 16);
	OLED_ShowString(8*13, 48, (UINT8*)"=E", 16);
	OLED_RefreshGram();
	
	strcpy((char*)&BLENOTIBUF[15], (char*)UONVAL_BUF);
	strcpy((char*)&BLENOTIBUF[15+len1], " V, hFE = ");
	strcpy((char*)&BLENOTIBUF[25+len1], (char*)HFEVAL_BUF);
	strcpy((char*)&BLENOTIBUF[25+len1+len2], "\n");
}


/*******************************************************************************
* Function Name  : JFET_Display
* Description    : JFETʾ(OLED+BLE)
* Input          : ComParam: Ԫ
* Return         : None
*******************************************************************************/
void JFET_Display(COMPONENTPARAMETER ComParam)
{
	UINT8 UOFFVAL_BUF[10];
	UINT8 IDSSVAL_BUF[10];
	UINT8 len1, len2;

	len1 = sprintf((char*)UOFFVAL_BUF, "%.1f", ComParam.JFETPARAM.Uoff); 
	len2 = sprintf((char*)IDSSVAL_BUF, "%.0f", 1000*ComParam.JFETPARAM.Idss);
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowNum(0, 10, ComParam.JFETPARAM.g-2, 1, 12);
	OLED_ShowNum(30, 0, ComParam.JFETPARAM.d-2, 1, 12);
	OLED_ShowNum(30, 20, ComParam.JFETPARAM.s-2, 1, 12);
	
	BLENOTIBUF_Clear();
	if(ComParam.JFETPARAM.Channel == P_CHANNEL)
	{
		OLED_ShowPJEFPic(9, 0);
		OLED_ShowString(44, 0, (UINT8*)"P-JFET", 16);
		strcpy((char*)BLENOTIBUF, "P-JFET: Uoff = ");
	}
	else if(ComParam.JFETPARAM.Channel == N_CHANNEL)
	{
		OLED_ShowNJEFPic(9, 0);
		OLED_ShowString(44, 0, (UINT8*)"N-JFET", 16);
		strcpy((char*)BLENOTIBUF, "N-JFET: Uoff = ");
	}
	
	OLED_ShowString(44, 16, (UINT8*)"Uoff=", 16);
	OLED_ShowString(84, 16, UOFFVAL_BUF, 16);
	OLED_ShowChar(8*len1+84, 16, 'V', 16);
	OLED_ShowString(44, 32, (UINT8*)"Idss=", 16);
	OLED_ShowString(84, 32, IDSSVAL_BUF, 16);
	OLED_ShowString(8*len2+84, 32, (UINT8*)"mA", 16);
	OLED_ShowString(0, 48, (UINT8*)"Pin ", 16);
	OLED_ShowNum(8*4, 48, ComParam.JFETPARAM.g-2, 1, 16);
	OLED_ShowString(8*5, 48, (UINT8*)"=G ", 16);
	OLED_ShowNum(8*8, 48, ComParam.JFETPARAM.d-2, 1, 16);
	OLED_ShowString(8*9, 48, (UINT8*)"=D ", 16);
	OLED_ShowNum(8*12, 48, ComParam.JFETPARAM.s-2, 1, 16);
	OLED_ShowString(8*13, 48, (UINT8*)"=S", 16);
	OLED_RefreshGram();
	

	strcpy((char*)&BLENOTIBUF[15], (char*)UOFFVAL_BUF);
	strcpy((char*)&BLENOTIBUF[15+len1], " V, Idss = ");
	strcpy((char*)&BLENOTIBUF[26+len1], (char*)IDSSVAL_BUF);
	strcpy((char*)&BLENOTIBUF[26+len1+len2], " mA\n");
}


/*******************************************************************************
* Function Name  : MOS_Display
* Description    : JFETʾ(OLED+BLE)
* Input          : ComParam: Ԫ
* Return         : None
*******************************************************************************/
void MOS_Display(COMPONENTPARAMETER ComParam)
{
	UINT8 UVAL_BUF[10];
	UINT8 IDSSVAL_BUF[10];
	UINT8 UDVAL_BUF[10];
	UINT8 len1, len2;
	
	OLED_Fill(0, 128, 0, 64, 0);
	OLED_ShowNum(0, 10, ComParam.MOSFETPARAM.g-2, 1, 12);
	OLED_ShowNum(30, 0, ComParam.MOSFETPARAM.d-2, 1, 12);
	OLED_ShowNum(30, 20, ComParam.MOSFETPARAM.s-2, 1, 12);
	
	BLENOTIBUF_Clear();
	if(ComParam.MOSFETPARAM.MODEL == E_MODEL)
	{
		if(ComParam.MOSFETPARAM.Channel == P_CHANNEL)
		{
			if(ComParam.MOSFETPARAM.Ud>0)
				OLED_ShowPEMOSDIOPic(9, 0);
			else
				OLED_ShowPEMOSPic(9, 0);
			OLED_ShowString(44, 0, (UINT8*)"P-E-MOS", 16);
			strcpy((char*)BLENOTIBUF, "P-E-MOS: Uon = ");
		}
		else if(ComParam.MOSFETPARAM.Channel == N_CHANNEL)
		{
			if(ComParam.MOSFETPARAM.Ud>0)
				OLED_ShowNEMOSDIOPic(9, 0);
			else
				OLED_ShowNEMOSPic(9, 0);
			OLED_ShowString(44, 0, (UINT8*)"N-E-MOS", 16);
			strcpy((char*)BLENOTIBUF, "N-E-MOS: Uon = ");
		}
		
		len1 = sprintf((char*)UVAL_BUF, "%.1f", ComParam.MOSFETPARAM.Uon);
		
		OLED_ShowString(44, 16, (UINT8*)"Uon=", 16);
		OLED_ShowString(76, 16, UVAL_BUF, 16);
		OLED_ShowChar(8*len1+76, 16, 'V', 16);
		
		strcpy((char*)&BLENOTIBUF[15], (char*)UVAL_BUF);
		strcpy((char*)&BLENOTIBUF[15+len1], " V");
		
		if(ComParam.MOSFETPARAM.Ud>0)
		{
			len2 = sprintf((char*)UDVAL_BUF, "%.1f", ComParam.MOSFETPARAM.Ud);
			
			OLED_ShowString(44, 32, (UINT8*)"Ud=", 16);
			OLED_ShowString(68, 32, UDVAL_BUF, 16);
			OLED_ShowChar(8*len2+68, 32, 'V', 16);
			
			strcpy((char*)&BLENOTIBUF[17+len1], ", Ud = ");
			strcpy((char*)&BLENOTIBUF[24+len1], (char*)UDVAL_BUF);
			strcpy((char*)&BLENOTIBUF[24+len1+len2], " V\n");
		}	
		else
		{
			strcpy((char*)&BLENOTIBUF[17+len1], "\n");
		}
	}
	else if(ComParam.MOSFETPARAM.MODEL == D_MODEL)
	{	
		if(ComParam.MOSFETPARAM.Channel == P_CHANNEL)
		{
			OLED_ShowPDMOSPic(9, 0);
			OLED_ShowString(44, 0, (UINT8*)"P-D-MOS", 16);
			strcpy((char*)BLENOTIBUF, "P-D-MOS: Uoff = ");	
		}
		else if(ComParam.MOSFETPARAM.Channel == N_CHANNEL)
		{
			OLED_ShowNDMOSPic(9, 0);
			OLED_ShowString(44, 0, (UINT8*)"N-D-MOS", 16);
			strcpy((char*)BLENOTIBUF, "N-D-MOS: Uoff = ");
		}
		
		len1 = sprintf((char*)UVAL_BUF, "%.1f", ComParam.MOSFETPARAM.Uoff); 
		len2 = sprintf((char*)IDSSVAL_BUF, "%.0f", 1000*ComParam.MOSFETPARAM.Idss);
		
		OLED_ShowString(44, 16, (UINT8*)"Uoff=", 16);
		OLED_ShowString(84, 16, UVAL_BUF, 16);
		OLED_ShowChar(8*len1+84, 16, 'V', 16);
		OLED_ShowString(44, 32, (UINT8*)"Idss=", 16);
		OLED_ShowString(84, 32, IDSSVAL_BUF, 16);
		OLED_ShowString(8*len2+84, 32, (UINT8*)"mA", 16);
		
		strcpy((char*)&BLENOTIBUF[16], (char*)UVAL_BUF);
		strcpy((char*)&BLENOTIBUF[16+len1], " V, Idss = ");
		strcpy((char*)&BLENOTIBUF[27+len1], (char*)IDSSVAL_BUF);
		strcpy((char*)&BLENOTIBUF[27+len1+len2], " mA\n");
	}
	
	OLED_ShowString(0, 48, (UINT8*)"Pin ", 16);
	OLED_ShowNum(8*4, 48, ComParam.MOSFETPARAM.g-2, 1, 16);
	OLED_ShowString(8*5, 48, (UINT8*)"=G ", 16);
	OLED_ShowNum(8*8, 48, ComParam.MOSFETPARAM.d-2, 1, 16);
	OLED_ShowString(8*9, 48, (UINT8*)"=D ", 16);
	OLED_ShowNum(8*12, 48, ComParam.MOSFETPARAM.s-2, 1, 16);
	OLED_ShowString(8*13, 48, (UINT8*)"=S", 16);
	
	OLED_RefreshGram();
}
