#ifndef __PARTCHECK_H
#define __PARTCHECK_H
#include <math.h>
#include <string.h>
#include "CH57x_common.h"
#include "gpio.h"
#include "adc.h"
#include "timer.h"

/************************** 궨 *************************************/
/* ƽ */
#define	LV_NEGATIVE			0				//͵ƽ
#define	LV_POSITIVE			1				//ߵƽ

/* Զ˶ӦADCͨ */
#define TP1							3				
#define TP2							4
#define TP3							5

/* ܼ */
#define P_CHANNEL				1				//P
#define	N_CHANNEL				2				//N

/* ͺ */
#define E_MODEL					1				//ǿ
#define	D_MODEL					2				//ľ

/* ܷ */
#define REVERSE					1				//
#define	FORWARD					2				//

/************************** öٱ *************************************/
/* Ԫ */
typedef enum _COMPONENTTYPE
{
	COMPONENT_NONE = 0,			//Ԫ
	COMPONENT_RESISTANCE,		//
	COMPONENT_CAPACITANCE,	//
	COMPONENT_INDUCTANCE,		//
	COMPONENT_DIODE,				//
	COMPONENT_BJT,					//˫;
	COMPONENT_JFET,				//JFET
	COMPONENT_MOS,					//MOS
}COMPONENTTYPE;

/* ˿ģʽѡ */
typedef enum _PORTMODE
{
	PORT_WITH_NONE = 0,			//δ
	PORT_WITH_680,					//680
	PORT_WITH_470K,					//470K
	PORT_FLOATING,					//ȫ
}PORTMODE;

/************************** ṹ *************************************/
/* ˿(Խ) */
typedef struct _MEASUREPORT
{
	UINT32 PIN_WITH_NONE;		//δ
	UINT32 PIN_WITH_680;		//680
	UINT32 PIN_WITH_470K;		//470K
}MEASUREPORT;

typedef struct _QUICKJUDGE
{
	UINT8 Bth;
	UINT8 Bht;
	UINT8 Btl;
	UINT8 Blt;	
	UINT8 Bhl;
	UINT8 Blh;
	UINT8 Sta[3];
}QUICKJUDGE;

/**************************  *************************************/
typedef union _COMPONENTPARAMETER
{
	struct _RESPARAM
	{
		UINT8 front;
		UINT8 rear;
		double ResVal;								//
	}RESPARAM;
	
	struct _CAPPARAM
	{
		UINT8 front;								//ӵݵ1
		UINT8 rear;									//ӵݵ2
		double CapVal;							//ݲ
	}CAPPARAM;
	
	struct _INDPARAM
	{
		UINT8 front;
		UINT8 rear;
		double IndVal;								//в
	}INDPARAM;
	
	struct _DIODEPARAM						//ܲ
	{
		UINT8 front;
		UINT8 rear;
		float Uon;  //ͨѹ
		float Cj;		//
	}DiodeParam;
	
	struct _BJTPARAM
	{
		UINT8 Channel;
		UINT8 c;							//缫ͨ
		UINT8 b;							//ͨ
		UINT8 e;							//伫ͨ
		UINT16 hFE;
		float Ube;
	}BJTPARAM;
	
	struct _JFETPARAM
	{
		UINT8 Channel;				//
		UINT8 d;							//©ͨ
		UINT8 g;							//դͨ
		UINT8 s;							//Դͨ
		float Uoff;						//жϵѹ
		float Idss;						//©
	}JFETPARAM;
	
	struct _MOSFETPARAM
	{
		UINT8 Channel;				//
		UINT8 MODEL;					//ͺ
		UINT8 d;							//©ͨ
		UINT8 g;							//դͨ
		UINT8 s;							//Դͨ
		float Uon;						//ѹ
		float Uoff;						//жϵѹ
		float Idss;						//©
		float Ud;							//ڲܵĵͨѹ
	}MOSFETPARAM;
	
}COMPONENTPARAMETER;


/*  */
void MeasurePort_Init(MEASUREPORT port, PORTMODE mode, UINT8 level);
void Component_Discharge(void);
UINT8 StringCompare(UINT8* pArr1, UINT8* pArr2, UINT8 len);
void Component_QuickCheck(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin);
UINT8 ComponentIsCAP_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin);
void Capacitance_Check(UINT8 FrontPin, UINT8 RearPin);
void BJT_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin);
void JFET_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin);
UINT8 ComponentIsEMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin, QUICKJUDGE* presult);
void EMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin);
void Diode_Check(UINT8 FrontPin, UINT8 RearPin);
UINT8 ComponentIsDMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin, QUICKJUDGE* presult);
void DMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin);
void Inductance_Check(UINT8 FrontPin, UINT8 RearPin);
void Resistance_Check(UINT8 FrontPin, UINT8 RearPin);
UINT8 ComponentIsRES_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin);

#endif
